import * as cdk from 'aws-cdk-lib';
import * as constructs from 'constructs';
/**
 * Manage the activation of a Tls Domain
 *
 * @schema CfnDomainProps
 */
export interface CfnDomainProps {
    /**
     * @schema CfnDomainProps#Relationships
     */
    readonly relationships?: Relationships;
    /**
     * @schema CfnDomainProps#Type
     */
    readonly type?: string;
    /**
     * @schema CfnDomainProps#Attributes
     */
    readonly attributes?: CfnDomainPropsAttributes;
}
/**
 * Converts an object of type 'CfnDomainProps' to JSON representation.
 */
export declare function toJson_CfnDomainProps(obj: CfnDomainProps | undefined): Record<string, any> | undefined;
/**
 * @schema Relationships
 */
export interface Relationships {
    /**
     * @schema Relationships#TlsCertificate
     */
    readonly tlsCertificate?: RelationshipsTlsCertificate;
    /**
     * @schema Relationships#TlsDomain
     */
    readonly tlsDomain?: RelationshipsTlsDomain;
    /**
     * @schema Relationships#TlsConfiguration
     */
    readonly tlsConfiguration?: RelationshipsTlsConfiguration;
}
/**
 * Converts an object of type 'Relationships' to JSON representation.
 */
export declare function toJson_Relationships(obj: Relationships | undefined): Record<string, any> | undefined;
/**
 * @schema CfnDomainPropsAttributes
 */
export interface CfnDomainPropsAttributes {
    /**
     * @schema CfnDomainPropsAttributes#CreatedAt
     */
    readonly createdAt?: Date;
}
/**
 * Converts an object of type 'CfnDomainPropsAttributes' to JSON representation.
 */
export declare function toJson_CfnDomainPropsAttributes(obj: CfnDomainPropsAttributes | undefined): Record<string, any> | undefined;
/**
 * @schema RelationshipsTlsCertificate
 */
export interface RelationshipsTlsCertificate {
    /**
     * @schema RelationshipsTlsCertificate#Data
     */
    readonly data?: Data;
}
/**
 * Converts an object of type 'RelationshipsTlsCertificate' to JSON representation.
 */
export declare function toJson_RelationshipsTlsCertificate(obj: RelationshipsTlsCertificate | undefined): Record<string, any> | undefined;
/**
 * @schema RelationshipsTlsDomain
 */
export interface RelationshipsTlsDomain {
    /**
     * @schema RelationshipsTlsDomain#Data
     */
    readonly data?: Data;
}
/**
 * Converts an object of type 'RelationshipsTlsDomain' to JSON representation.
 */
export declare function toJson_RelationshipsTlsDomain(obj: RelationshipsTlsDomain | undefined): Record<string, any> | undefined;
/**
 * @schema RelationshipsTlsConfiguration
 */
export interface RelationshipsTlsConfiguration {
    /**
     * @schema RelationshipsTlsConfiguration#Data
     */
    readonly data?: Data;
}
/**
 * Converts an object of type 'RelationshipsTlsConfiguration' to JSON representation.
 */
export declare function toJson_RelationshipsTlsConfiguration(obj: RelationshipsTlsConfiguration | undefined): Record<string, any> | undefined;
/**
 * @schema Data
 */
export interface Data {
    /**
     * @schema Data#Type
     */
    readonly type?: string;
    /**
     * @schema Data#Id
     */
    readonly id?: string;
}
/**
 * Converts an object of type 'Data' to JSON representation.
 */
export declare function toJson_Data(obj: Data | undefined): Record<string, any> | undefined;
/**
 * A CloudFormation `Fastly::Tls::Domain`
 *
 * @cloudformationResource Fastly::Tls::Domain
 * @stability external
 * @link https://github.com/aws-ia/cloudformation-fastly-resource-providers
 */
export declare class CfnDomain extends cdk.CfnResource {
    /**
    * The CloudFormation resource type name for this resource class.
    */
    static readonly CFN_RESOURCE_TYPE_NAME = "Fastly::Tls::Domain";
    /**
     * Resource props.
     */
    readonly props: CfnDomainProps;
    /**
     * Attribute `Fastly::Tls::Domain.Id`
     * @link https://github.com/aws-ia/cloudformation-fastly-resource-providers
     */
    readonly attrId: string;
    /**
     * Create a new `Fastly::Tls::Domain`.
     *
     * @param scope - scope in which this resource is defined
     * @param id    - scoped id of the resource
     * @param props - resource properties
     */
    constructor(scope: constructs.Construct, id: string, props: CfnDomainProps);
}
